<template>
  <div class="form-container u-mb-30">
    <FormValidation v-if="errors.length > 0" :errors="errors" />
    <form @submit.prevent="onSubmit">
      <div class="field required">
        <label class="label">Firstname</label>
        <div class="control">
          <input
            class="input"
            type="text"
            placeholder="e.g. John"
            v-model="user.firstName"
          />
        </div>
      </div>
      <div class="field required">
        <label class="label">Lastname</label>
        <div class="control">
          <input
            class="input"
            type="text"
            placeholder="e.g. Doe"
            v-model="user.lastName"
          />
        </div>
      </div>
      <div class="field required">
        <label class="label">Email</label>
        <div class="control">
          <input
            class="input"
            type="email"
            placeholder="e.g. johndoe@email.ext"
            v-model="user.email"
          />
        </div>
      </div>
      <p class="help has-text-grey-light u-mb-30">
        * Fields marked with an asterisk (*) are required
      </p>
      <input type="submit" value="Submit" class="button is-primary" />
    </form>
  </div>
</template>

<script>
import { mapActions } from "vuex";
import FormValidation from "@/components/FormValidation.vue";

export default {
  name: "CreateUserForm",
  data() {
    return {
      user: {
        firstName: "",
        lastName: "",
        email: ""
      },
      errors: []
    };
  },
  methods: {
    ...mapActions(["CREATE_USER"]),
    onSubmit() {
      this.errors.length = 0;
      if (this.user.firstName && this.user.lastName && this.user.email) {
        this.CREATE_USER(this.user);
      } else {
        if (!this.user.firstName) this.errors.push("Firstname is required.");
        if (!this.user.lastName) this.errors.push("Lastname is required.");
        if (!this.user.email) this.errors.push("Email is required.");
      }
    }
  },
  components: {
    FormValidation
  }
};
</script>
